//
//  PhobosDataManager.h
//  GMCache
//
//  Created by Locus on 2020/1/21.
//

#import <Foundation/Foundation.h>
#import <MagicalRecord/MagicalRecord.h>
#import "SendDataEntity+CoreDataClass.h"

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, PhobosDataSendStatus) {
    PhobosDataSendStatusNormal         = 0, // 普通埋点数据
    PhobosDataSendStatusToBeSend       = 1, // 待发送数据
    PhobosDataSendStatusSending        = 2, // 发送中数据
    PhobosDataSendStatusFinish         = 3, // 发送完成数据
    PhobosDataSendStatusError          = 4, // 发送失败数据
};

@interface PhobosDataManager : NSObject

/** 获取待发送数据，包含待发送数据和发送失败数据 */
+ (NSArray<SendDataEntity *> *)fetchToBeSendDataEntities;
+ (NSArray<SendDataEntity *> *)fetchDataEntitiesWithPredicate:(NSPredicate *)searchFilter;
+ (NSUInteger)fetchCountOfToBeSendEntities;
+ (NSUInteger)fetchCountOfEntitiesWithPredicate:(NSPredicate *)searchFilter;

+ (void)insertData:(NSDictionary *)data sendAPI:(NSString *)sendAPI completion:(MRSaveCompletionHandler)completion;

+ (void)updateDataEntities:(NSArray<SendDataEntity *> *)entities sendStatus:(PhobosDataSendStatus)sendStatus completion:(MRSaveCompletionHandler)completion;

+ (void)deleteDataEntities:(NSArray<SendDataEntity *> *)entities;
+ (void)deleteAllEntities;

@end

NS_ASSUME_NONNULL_END
